// Copyright 2017 by Yun Xiang, Tam Chantem, and Robert Dick.
// All rights reserved.

/*Copyright 2010, Yun Xiang<xiangyun@umich.edu>.*/
#include <iostream>
#include <limits>

#ifndef CONT_H_
#define CONT_H_

// global definition
//#define DEBUG
//#define XY_DEBUG
// This is to differentiate the modification done by me and Chantenm
//#define XY_VER 
//#define XY_ONLINE
//#define INF std::numeric_limits<double>::max() 
#define INF 1e99
#ifndef XY_ONLINE
#define MAX_TRIAL 1000000
#else
#define MAX_TRIAL 1
#endif
				
#define REF_MU 20

// define constants for TC
#define TC_thresh 1.0
#define TC_A 1.0
#define TC_B 2.0    //coeffiecnt for averafe temp
#define TC_Ea 0.42
//#define T_MOLD 500  //molding temperature,kelvin
#define TC_Q -8.0
#define REF_TDIFF 20 //should be 20 here
#define REF_TMAX 70 //reference MAX temperature, should be 70
//#define REF_TC_CYCLE 10000 //10^7!
//#define REF_TC_CYCLE 100000000//10^8

// define some constant values used in the reliability model
#define Boltzmann 8.62E-5

#define EM_Ea 0.9
#define EM_n 1.1

#define T_ambient 45
#define TC_q 2.35

#define SM_Ea 0.9
#define SM_t0 500
#define SM_n 2.5

#define TDDB_a 78/20 //too large originally, literature say 2~5, scale to that value
#define TDDB_b -0.081/20
#define TDDB_A 0.759
#define TDDB_B -66.8
#define TDDB_C -8.37E-4

#define LOGN_SIGMA 0.5
#define WBL_SIGMA_EM 5.0
#define WBL_SIGMA_TC 5.0
#define WBL_SIGMA_SM 5.0
#define WBL_SIGMA_TDDB 5.0

#define REF_EM_MTTF 30
#define REF_TC_MTTF 30
#define REF_SM_MTTF 30
#define REF_TDDB_MTTF 30

#define REF_VOLTAGE 1.8
#define REF_TEMPERATURE 60 
#define REF_FREQUENCE 500

//#define AMBIENT_TEMP 25

const double LTEMPERATURE = 20;
const double RTEMPERATURE = 100;
const double TEMPERATURE_STEP = 0.1;

const double LVOLTAGE = 1.0;
const double RVOLTAGE = 3.0;
const double VOLTAGE_STEP = 0.2;

const double MTTF_CONST = 8;
const int MROUND=1e06;
//double TIME_STEPS = 0.01;

//*********class definition***********************//
class Cycle {
 public:
          Cycle() { }
	  double peak;
	  double swing;	  
	  int index;

};


#endif
